#include "FPS.h"

FPS::FPS(unsigned interval_ms)
:	interval_ms( interval_ms ),
	fps( 0 )
{}

FPS::~FPS()
{}

float FPS::get_fps()const
{
	return fps;
}

void FPS::record(unsigned time_ms)
{
	records.push_back( time_ms );

	while( records.front() + interval_ms < time_ms )
		records.pop_front();

	int dt = time_ms - records.front();
	fps = (dt == 0) ? 0 : records.size() * 1000 / dt;
}
