#include "PictureFormatManager.h"
#include "BMPPictureFormat.h"
#include "TwinPictureFormat.h"
#include "safe_new.h"

PictureFormat * PictureFormatManager::create_format(const String & name)
{
	TwinPictureFormat * twinf = new TwinPictureFormat( name );
	if( twinf->colors() )
		return twinf;
	delete twinf; twinf = 0;

	BMPPictureFormat * bmpf = new BMPPictureFormat( name );
	if( bmpf->colors() )
		return bmpf;
	delete bmpf; bmpf = 0;

	return 0;
}
